#!/bin/bash -

# input check
[[ ("$1" == "setup" && ("$2" == "sender" || "$2" == "receiver")) || "$1" == "restore" ]] || { echo "Help: sudo ./setuphl.sh (setup sender|receiver)|restore"; exit 1; }

# sanity check
ethtool -C eth0 rx-usecs 0
ethtool -K eth0 tso off
ethtool -K eth0 gso off
ethtool -K eth0 lro off
ethtool -K eth0 gro off

# tcp flavor check
modprobe tcp_lp
sysctl -w net.ipv4.tcp_allowed_congestion_control="cubic reno lp"

# main procedure
if [[ "$1" == "setup" ]]; then
	if [[ "$2" == "sender" ]]; then
		ifconfig eth0 10.0.0.1 netmask 255.255.255.0
	elif [[ "$2" == "receiver" ]]; then
		ifconfig eth0 10.0.0.2 netmask 255.255.255.0
	fi
	#route add -net 10.0.0.0 netmask 255.255.255.0 dev eth0

elif [[ "$1" == "restore" ]]; then
	read -a ans -n 1 -p "DHCP accessible? [y/N]:"
	if [[ "$ans" == "y" ]]; then
		#/etc/init.d/networking restart
		echo "Restarting..."
		ifdown --force eth0
		ifup eth0
	fi
fi

# result verifiy
str=$(ifconfig eth0 | grep 'inet addr')
echo ${str:1}



