#!/bin/bash -

# input check
[[ $1 != *[!0-9]* && $1 -gt 0 && ( "$2" == "utp" || "$2" == "lp" ) ]] || { echo "Help: sudo ./start_receiver.sh flows cctype [d(direct start, skip ip check)]"; exit 1; }
flow=$1
cctype=$2

# environment check
if [[ "$3" != "d" ]]; then
	echo $(ifconfig eth0 | grep 'inet addr')
	read -a ans -n 1 -p "Ready? [Y/n]:"
	[[ "$ans" == "n" ]] && { exit 1; }
fi

# cleanup
killall -9 -q iperf
killall -9 -q utp_recv
killall -9 -q tcpdump.hack

# timestamp
ts=$(date +%m%d%H%M)

# start running
# 1-port server
#$(pwd)/bin/iperf -s &
while [[ $flow -gt 0 ]]; do
	# multi/port server
	$(pwd)/bin/iperf -s -p $(( 5000 + $flow )) &
	[[ "$cctype" == "utp" ]] && { $(pwd)/bin/utp_recv tmp/utp_recv.$ts.$flow.log $(( 6000 + $flow )) tmp/payload.$flow.recv & }
	[[ "$cctype" == "lp" ]] && { $(pwd)/bin/iperf -s -p $(( 6000 + $flow )) & }
	(( flow = flow - 1 ))
done
$(pwd)/bin/tcpdump.hack -i eth0 -w tmp/trace.$ts.pcap -n -t -t  tcp or udp or icmp

# cleanup
killall -9 -q iperf
killall -9 -q utp_recv
killall -9 -q tcpdump.hack


# obsolute code

# timestamp
#tag=$3
#[[ "$3" != "" ]] && { tag="$3."; }

# start running
#$(pwd)/bin/utp_recv tmp/utp_recv.$ts.${tag}log 5001 tmp/payload.recv &
#$(pwd)/bin/tcpdump.hack -i eth0 -w tmp/trace.$ts.${tag}pcap -n -t -t  tcp or udp or icmp
