#!/bin/bash -

# input check
[[ $1 != *[!0-9]* && $1 -gt 0 && ( "$2" == "utp" || "$2" == "lp" ) ]] || { echo "Help: sudo ./start_sender.sh flows cctype [d(direct start, skip ip check)]"; exit 1; }
flow=$1
cctype=$2

# environment check
if [[ "$3" != "d" ]]; then
	[[ -f $(pwd)/tmp/payload.send ]] || { echo "Forget payload.send :P"; exit; }

	echo $(ifconfig eth0 | grep 'inet addr')
	tc qdisc show dev eth0
	read -a ans -n 1 -p "Ready? [Y/n]:"
	[[ "$ans" == "n" ]] && { exit 1; }
fi

# link check
src=$( ifconfig eth0 | grep 'inet addr' | awk -F: '{ print $2 }' | awk '{ print $1 }' )
dst="10.0.0.1"
[[ $src == "10.0.0.1" ]] && dst="10.0.0.2"

# cleanup
killall -9 -q ping
killall -9 -q iperf
killall -9 -q utp_send

# timestamp
ts=$(date +%m%d%H%M)

# start running
#ping -n $dst | awk -v flog="tmp/ping.$ts.log" '/^[0-9]+ bytes from / { "date +%s" | getline pong; close("date +%s"); print pong,substr($7,6) > flog; fflush(flog); }' &
ping -n -i 0.1 -c 100 $dst > tmp/ping.$ts.base.log & 
echo "sleep 10 seconds to get base ttl..."
sleep 10

while [[ $flow -gt 0 ]]; do
	# use 1-port server
	#$(pwd)/bin/iperf -i 1 -c $dst -t 600 -Z reno > tmp/tcp.iperf.$ts.$flow.log &
	# use multi-port server
	$(pwd)/bin/iperf -i 1 -c $dst -p $(( 5000 + $flow )) -t 600 -Z reno > tmp/tcp.iperf.$ts.$flow.log &
	[[ "$cctype" == "utp" ]] && { $(pwd)/bin/utp_send tmp/ccp.utp_send.$ts.$flow.log $dst:$(( 6000 + $flow )) tmp/payload.send & }
	[[ "$cctype" == "lp" ]] && { $(pwd)/bin/iperf -i 1 -c $dst -p $(( 6000 + $flow )) -t 600 -Z lp > tmp/ccp.iperf.$ts.$flow.log & }	
	(( flow = flow - 1 ))
done
ping -n -i 0.1 -c 600 $dst | tee tmp/ping.$ts.data.log
#ping -n $dst #| tee tmp/ping.log

# cleanup
killall -9 -q ping
killall -9 -q iperf
killall -9 -q utp_send


# obsolute code

# timestamp
#tag=$3
#[[ "$3" != "" ]] && { tag="$3."; }

# start running
#ping -n $dst > tmp/ping.$ts.log &
#ping $dst > tmp/ping.$ts.${tag}log &
#$(pwd)/bin/iperf -i 1 -c $dst -t 600 > tmp/iperf.$ts.${tag}log &
#$(pwd)/bin/utp_send tmp/utp_send.$ts.${tag}log $dst:5001 tmp/payload.send 2>tmp/utp_send.$ts.${tag}err #| tee tmp/utp_send.$ts.${tag}out
